//+------------------------------------------------------------------+
//|                                               HL_Channel_ind.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, LeMan."
#property link      "b-market@mail.ru"
//----
#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_color3 Green
#property indicator_color4 Red
#property indicator_color5 Green
#property indicator_color6 Red
#property indicator_color7 Green
#property indicator_color8 Red
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width5 2
#property indicator_width6 2
#property indicator_width7 1
#property indicator_width8 1
//----
extern int    N=12;
//----
double OpenUp[];
double OpenDw[];
double StopUp[];
double StopDn[];
double StartUp[];
double StartDw[];
double Hi[];
double Lo[];
//+------------------------------------------------------------------+
int init() 
{
//----
   IndicatorDigits(Digits);
   IndicatorBuffers(8);
//----      
   SetIndexBuffer(0,OpenUp);
   SetIndexBuffer(1,OpenDw);
   SetIndexBuffer(2,StopUp);
   SetIndexBuffer(3,StopDn);
   SetIndexBuffer(4,StartUp);
   SetIndexBuffer(5,StartDw);
   SetIndexBuffer(6,Lo);
   SetIndexBuffer(7,Hi);

   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,159);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,159);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexStyle(6,DRAW_LINE,STYLE_DOT);
   SetIndexStyle(7,DRAW_LINE,STYLE_DOT);
//----      
   return(0);
}
//+------------------------------------------------------------------+
int start() 
{
   int i,limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   if(counted_bars==0) limit-=3;

   for(i=0; i<limit; i++) 
   {
      OpenUp[i]=0;
      OpenDw[i]=0;
      double hl1 = iLow(NULL,0,iHighest(NULL,0,MODE_LOW, N,i+1));
      double hl2 = iLow(NULL,0,iHighest(NULL,0,MODE_LOW, N,i+2));
      double lh1 = iHigh(NULL,0,iLowest(NULL,0,MODE_HIGH,N,i+1));
      double lh2 = iHigh(NULL,0,iLowest(NULL,0,MODE_HIGH,N,i+2));
      
      if(Low [i+2]<=lh2 && Low [i+1]>lh1) OpenUp[i] = Open[i]; 
      if(High[i+2]>=hl2 && High[i+1]<hl1) OpenDw[i] = Open[i];
      
      StopUp[i] = iLow (NULL,0,iLowest (NULL,0,MODE_LOW, N,i+1));
      StopDn[i] = iHigh(NULL,0,iHighest(NULL,0,MODE_HIGH,N,i+1));
      
      StartUp[i]=lh1;
      StartDw[i]=hl1;
      
      Hi[i]=High[i];
      Lo[i]=Low[i];
   }

//----
   return(0);
}
//+------------------------------------------------------------------+